% The Rust Programming Language

Welcome! This book will teach you about [the Rust Programming
Language](http://www.rust-lang.org/). Rust is a modern systems programming
language focusing on safety and speed. It accomplishes these goals by being
memory safe without using garbage collection.

"The Rust Programming Language" is split into three sections, which you can
navigate through the menu on the left.

<h2 class="section-header"><a href="basic.html">Basics</a></h2>

This section is a linear introduction to the basic syntax and semantics of
Rust. It has individual sections on each part of Rust's syntax, and culminates
in a small project: a guessing game.

After reading "Basics," you will have a good foundation to learn more about
Rust, and can write very simple programs.

<h2 class="section-header"><a href="intermediate.html">Intermediate</a></h2>

This section contains individual chapters, which are self-contained. They focus
on specific topics, and can be read in any order.

After reading "Intermediate," you will have a solid understanding of Rust,
and will be able to understand most Rust code and write more complex programs.

<h2 class="section-header"><a href="advanced.html">Advanced</a></h2>

In a similar fashion to "Intermediate," this section is full of individual,
deep-dive chapters, which stand alone and can be read in any order. These
chapters focus on the most complex features, as well as some things that
are only available in upcoming versions of Rust.

After reading "Advanced," you'll be a Rust expert!
