# Summary

* [I: The Basics](basic.md)
    * [Installing Rust](installing-rust.md)
    * [Hello, world!](hello-world.md)
    * [Hello, Cargo!](hello-cargo.md)
    * [Variable Bindings](variable-bindings.md)
    * [If](if.md)
    * [Functions](functions.md)
    * [Comments](comments.md)
    * [Compound Data Types](compound-data-types.md)
    * [Match](match.md)
    * [Looping](looping.md)
    * [Strings](strings.md)
    * [Arrays, Vectors, and Slices](arrays-vectors-and-slices.md)
    * [Standard Input](standard-input.md)
    * [Guessing Game](guessing-game.md)
* [II: Intermediate Rust](intermediate.md)
    * [More Strings](more-strings.md)
    * [Crates and Modules](crates-and-modules.md)
    * [Testing](testing.md)
    * [Pointers](pointers.md)
    * [Ownership](ownership.md)
    * [Patterns](patterns.md)
    * [Method Syntax](method-syntax.md)
    * [Closures](closures.md)
    * [Iterators](iterators.md)
    * [Generics](generics.md)
    * [Traits](traits.md)
    * [Static and Dynamic Dispatch](static-and-dynamic-dispatch.md)
    * [Macros](macros.md)
    * [Concurrency](concurrency.md)
    * [Error Handling](error-handling.md)
    * [Documentation](documentation.md)
* [III: Advanced Topics](advanced.md)
    * [FFI](ffi.md)
    * [Unsafe Code](unsafe.md)
    * [Advanced Macros](advanced-macros.md)
    * [Compiler Plugins](plugins.md)
* [Conclusion](conclusion.md)
* [Glossary](glossary.md)
